searchNodes=[{"doc":"Builder for paths concatenation (with ~&gt;)","ref":"Pathex.Builder.Composition.Concat.html","title":"Pathex.Builder.Composition.Concat","type":"module"},{"doc":"Callback implementation for Pathex.Builder.Composition.build/1.","ref":"Pathex.Builder.Composition.Concat.html#build/1","title":"Pathex.Builder.Composition.Concat.build/1","type":"function"},{"doc":"Main module. Use it inside your project to call Pathex macrosTo use it just insertdefmodule MyModule do require Pathex import Pathex, only: [path: 1, path: 2, &quot;~&gt;&quot;: 2, ...] ... endOr you can use usedefmodule MyModule do # default_mod option is optional use Pathex, default_mod: :json ... endThis will import all operatiors and path macroNote: There is no __using__/2 macro avaliable here because it would be better to explicitly define that the Pathex is used and what macros are exportedAny macro here belongs to one of two categories:Macro which creates path closure (sigil_P/2, path/2, ~&gt;/2)Macro which uses path closure as path (over/3, set/3, view/2, etc.)","ref":"Pathex.html","title":"Pathex","type":"module"},{"doc":"Creates composition of two paths which has some inspiration from logical andExample:iex&gt; require Pathex; import Pathex iex&gt; p1 = path :x / :y iex&gt; p2 = path :a / :b iex&gt; ap = p1 &amp;&amp;&amp; p2 iex&gt; {:ok, 1} = view %{x: %{y: 1}, a: [b: 1]}, ap iex&gt; :error = view %{x: %{y: 1}, a: [b: 2]}, ap iex&gt; {:ok, %{x: %{y: 2}, a: [b: 2]}} = set %{x: %{y: 1}, a: [b: 1]}, ap, 2 iex&gt; {:ok, %{x: %{y: 2}, a: %{b: 2}}} = force_set %{}, ap, 2","ref":"Pathex.html#&&&/2","title":"Pathex.&&&/2","type":"macro"},{"doc":"Creates composition of two paths which has some inspiration from logical orExample:iex&gt; require Pathex; import Pathex iex&gt; p1 = path :x / :y iex&gt; p2 = path :a / :b iex&gt; op = p1 ||| p2 iex&gt; {:ok, 1} = view %{x: %{y: 1}, a: [b: 2]}, op iex&gt; {:ok, 2} = view %{x: 1, a: [b: 2]}, op iex&gt; {:ok, %{x: %{y: 2}, a: [b: 1]}} = set %{x: %{y: 1}, a: [b: 1]}, op, 2 iex&gt; {:ok, %{x: %{y: 2}}} = force_set %{}, op, 2 iex&gt; {:ok, %{x: %{}, a: [b: 1]}} = force_set %{x: %{y: 1}, a: [b: 1]}, op, 2","ref":"Pathex.html#%7C%7C%7C/2","title":"Pathex.|||/2","type":"macro"},{"doc":"Creates composition of two paths similar to concating them togetherExample:iex&gt; require Pathex; import Pathex iex&gt; p1 = path :x / :y iex&gt; p2 = path :a / :b iex&gt; composed_path = p1 ~&gt; p2 iex&gt; {:ok, 1} = view %{x: [y: [a: [a: 0, b: 1]]]}, composed_path","ref":"Pathex.html#~%3E/2","title":"Pathex.~>/2","type":"macro"},{"doc":"This macro creates compositions of paths which work along with each otherExample:iex&gt; require Pathex; import Pathex iex&gt; p1 = path :x iex&gt; p2 = path :y iex&gt; pa = alongside [p1, p2] iex&gt; {:ok, [1, 2]} = view(%{x: 1, y: 2}, pa) iex&gt; {:ok, %{x: 3, y: 3}} = set(%{x: 1, y: 2}, pa, 3) iex&gt; :error = set(%{x: 1}, pa, 3) iex&gt; {:ok, %{x: 1, y: 1}} = force_set(%{}, pa, 1)","ref":"Pathex.html#alongside/1","title":"Pathex.alongside/1","type":"macro"},{"doc":"Macro returns function applyed to the value in the path or errorExample:iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; {:ok, 9} = at [0, %{x: 8}], path(x / :x), fn x -&gt; x + 1 end iex&gt; p = path &quot;hey&quot; / 0 iex&gt; {:ok, {:here, 9}} = at(%{&quot;hey&quot; =&gt; {9, -9}}, p, &amp; {:here, &amp;1})","ref":"Pathex.html#at/3","title":"Pathex.at/3","type":"macro"},{"doc":"Macro returns function applyed to the value in the path or errorExample:iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; 9 = at! [0, %{x: 8}], path(x / :x), fn x -&gt; x + 1 end iex&gt; p = path &quot;hey&quot; / 0 iex&gt; {:here, 9} = at!(%{&quot;hey&quot; =&gt; {9, -9}}, p, &amp; {:here, &amp;1})","ref":"Pathex.html#at!/3","title":"Pathex.at!/3","type":"macro"},{"doc":"Macro of four arguments which applies given function in the given path of given structureIf the path does not exist it creates the path favouring maps when structure is unknown and inserts default valueExample:iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; {:ok, [0, %{x: {:xxx, 8}}]} = force_over([0, %{x: 8}], path(x / :x), &amp; {:xxx, &amp;1}, 123) iex&gt; p = path &quot;hey&quot; / 0 iex&gt; {:ok, %{&quot;hey&quot; =&gt; %{0 =&gt; 1}}} = force_over(%{}, p, fn x -&gt; x + 1 end, 1)If the item in path doesn't have the right type, it returns :error Example:iex&gt; require Pathex; import Pathex iex&gt; p = path &quot;hey&quot; / &quot;you&quot; iex&gt; :error = force_over %{&quot;hey&quot; =&gt; {1, 2}}, p, fn x -&gt; x end, &quot;value&quot;Note: Default &quot;default&quot; value is nil","ref":"Pathex.html#force_over/4","title":"Pathex.force_over/4","type":"macro"},{"doc":"Macro of four arguments which applies given function in the given path of given structureIf the path does not exist it creates the path favouring maps when structure is unknown and inserts default valueExample:iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; [0, %{x: {:xxx, 8}}] = force_over!([0, %{x: 8}], path(x / :x), &amp; {:xxx, &amp;1}, 123) iex&gt; p = path &quot;hey&quot; / 0 iex&gt; %{&quot;hey&quot; =&gt; %{0 =&gt; 1}} = force_over!(%{}, p, fn x -&gt; x + 1 end, 1)If the item in path doesn't have the right type, it raises Example:iex&gt; require Pathex; import Pathex iex&gt; p = path &quot;hey&quot; / &quot;you&quot; iex&gt; force_over! %{&quot;hey&quot; =&gt; {1, 2}}, p, fn x -&gt; x end, &quot;value&quot; ** (Pathex.Error) Type mismatch in structureNote: Default default value is nil","ref":"Pathex.html#force_over!/4","title":"Pathex.force_over!/4","type":"macro"},{"doc":"Macro of three arguments which sets the given value in the given path of given structureIf the path does not exist it creates the path favouring maps when structure is unknownExample:iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; {:ok, [0, %{x: 123}]} = force_set [0, %{x: 8}], path(x / :x), 123 iex&gt; p = path &quot;hey&quot; / 0 iex&gt; {:ok, %{&quot;hey&quot; =&gt; %{0 =&gt; 1}}} = force_set %{}, p, 1If the item in path doesn't have the right type, it returns :error Example:iex&gt; require Pathex; import Pathex iex&gt; p = path &quot;hey&quot; / &quot;you&quot; iex&gt; :error = force_set %{&quot;hey&quot; =&gt; {1, 2}}, p, &quot;value&quot;","ref":"Pathex.html#force_set/3","title":"Pathex.force_set/3","type":"macro"},{"doc":"Macro of three arguments which sets the given value in the given path of given structureIf the path does not exist it creates the path favouring maps when structure is unknownExample:iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; [0, %{x: 123}] = force_set! [0, %{x: 8}], path(x / :x), 123 iex&gt; p = path &quot;hey&quot; / 0 iex&gt; %{&quot;hey&quot; =&gt; %{0 =&gt; 1}} = force_set! %{}, p, 1If the item in path doesn't have the right type, it raises Example:iex&gt; require Pathex; import Pathex iex&gt; p = path &quot;hey&quot; / &quot;you&quot; iex&gt; force_set! %{&quot;hey&quot; =&gt; {1, 2}}, p, &quot;value&quot; ** (Pathex.Error) Type mismatch in structure","ref":"Pathex.html#force_set!/3","title":"Pathex.force_set!/3","type":"macro"},{"doc":"Macro gets the value in the given path of the given structure or returns default value if not foundExample:iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; 8 = get [0, %{x: 8}], path(x / :x) iex&gt; p = path &quot;hey&quot; / &quot;you&quot; iex&gt; :default = get %{&quot;hey&quot; =&gt; [x: 1]}, p, :default","ref":"Pathex.html#get/3","title":"Pathex.get/3","type":"macro"},{"doc":"Macro of three arguments which applies given function for item in the given path of given structure and returns modified structureExample:iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; inc = fn x -&gt; x + 1 end iex&gt; {:ok, [0, %{x: 9}]} = over [0, %{x: 8}], path(x / :x), inc iex&gt; p = path &quot;hey&quot; / 0 iex&gt; {:ok, %{&quot;hey&quot; =&gt; [2, [2]]}} = over %{&quot;hey&quot; =&gt; [1, [2]]}, p, incNote: Exceptions from passed function left unhandlediex&gt; require Pathex; import Pathex iex&gt; over(%{1 =&gt; &quot;x&quot;}, path(1), fn x -&gt; x + 1 end) ** (ArithmeticError) bad argument in arithmetic expression","ref":"Pathex.html#over/3","title":"Pathex.over/3","type":"macro"},{"doc":"Macro of three arguments which applies given function for item in the given path of given structureExample:iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; inc = fn x -&gt; x + 1 end iex&gt; [0, %{x: 9}] = over! [0, %{x: 8}], path(x / :x), inc iex&gt; p = path &quot;hey&quot; / 0 iex&gt; %{&quot;hey&quot; =&gt; [2, [2]]} = over! %{&quot;hey&quot; =&gt; [1, [2]]}, p, inc","ref":"Pathex.html#over!/3","title":"Pathex.over!/3","type":"macro"},{"doc":"Creates path for given structureExample:iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; mypath = path 1 / :atom / &quot;string&quot; / {&quot;tuple?&quot;} / x iex&gt; structure = [0, [atom: %{&quot;string&quot; =&gt; %{{&quot;tuple?&quot;} =&gt; %{1 =&gt; 2}}}]] iex&gt; {:ok, 2} = view structure, mypathDefault modifier of this path/2 is :naive which means thatevery variable is treated as index / key to any of tuple, list, map, keywordevery atom is treated as key to map or keywordevery integer is treated as index to tuple, list or key to mapevery other data is treated as key to mapNote:-1 allows data to be prepended to the listiex&gt; require Pathex; import Pathex iex&gt; x = -1 iex&gt; p1 = path(-1) iex&gt; p2 = path(x) iex&gt; {:ok, [1, 2]} = force_set([2], p1, 1) iex&gt; {:ok, [1, 2]} = force_set([2], p2, 1)","ref":"Pathex.html#path/2","title":"Pathex.path/2","type":"macro"},{"doc":"Macro of three arguments which sets the given value in the given path of given structureExample:iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; {:ok, [0, %{x: 123}]} = set [0, %{x: 8}], path(x / :x), 123 iex&gt; p = path &quot;hey&quot; / 0 iex&gt; {:ok, %{&quot;hey&quot; =&gt; [123, [2]]}} = set %{&quot;hey&quot; =&gt; [1, [2]]}, p, 123","ref":"Pathex.html#set/3","title":"Pathex.set/3","type":"macro"},{"doc":"Macro of three arguments which sets the given value in the given path of given structureExample:iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; [0, %{x: 123}] = set! [0, %{x: 8}], path(x / :x), 123 iex&gt; p = path &quot;hey&quot; / 0 iex&gt; %{&quot;hey&quot; =&gt; [123, [2]]} = set! %{&quot;hey&quot; =&gt; [1, [2]]}, p, 123","ref":"Pathex.html#set!/3","title":"Pathex.set!/3","type":"macro"},{"doc":"Sigil for paths. Three modifiers are avaliable:naive (default) paths should look like ~P[&quot;string&quot;/:atom/1]json paths should look like ~P[string/this_one_is_too/1/0]jsonmap paths should look like ~P[:x/1]mapExample:iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; mypath = path 1 / :atom / &quot;string&quot; / {&quot;tuple?&quot;} / x iex&gt; structure = [0, [atom: %{&quot;string&quot; =&gt; %{{&quot;tuple?&quot;} =&gt; %{1 =&gt; 2}}}]] iex&gt; {:ok, 2} = view structure, mypath","ref":"Pathex.html#sigil_P/2","title":"Pathex.sigil_P/2","type":"macro"},{"doc":"Macro gets the value in the given path of the given structureExample:iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; {:ok, 8} = view [0, %{x: 8}], path(x / :x) iex&gt; p = path &quot;hey&quot; / 0 iex&gt; {:ok, 9} = view %{&quot;hey&quot; =&gt; {9, -9}}, p","ref":"Pathex.html#view/2","title":"Pathex.view/2","type":"macro"},{"doc":"Macro gets the value in the given path of the given structureExample:iex&gt; require Pathex; import Pathex iex&gt; x = 1 iex&gt; 8 = view! [0, %{x: 8}], path(x / :x) iex&gt; p = path &quot;hey&quot; / 0 iex&gt; 9 = view! %{&quot;hey&quot; =&gt; {9, -9}}, p","ref":"Pathex.html#view!/2","title":"Pathex.view!/2","type":"macro"},{"doc":"More about modifiers","ref":"Pathex.html#t:mod/0","title":"Pathex.mod/0","type":"type"},{"doc":"This depends on the modifier","ref":"Pathex.html#t:pathex_compatible_structure/0","title":"Pathex.pathex_compatible_structure/0","type":"type"},{"doc":"Value returned by non-bang path call","ref":"Pathex.html#t:result/0","title":"Pathex.result/0","type":"type"},{"doc":"Also known as path-closure","ref":"Pathex.html#t:t/0","title":"Pathex.t/0","type":"type"},{"doc":"Module with collection of prebuilt paths","ref":"Pathex.Lenses.html","title":"Pathex.Lenses","type":"module"},{"doc":"Path function which works with all possible keys it can find It takes all keys and than applies inner function (or concated path) If any application fails, this lens returns :errorExample:iex&gt; require Pathex; import Pathex iex&gt; alll = Pathex.Lenses.all() iex&gt; [%{x: 1}, [x: 2]] = Pathex.over!([%{x: 0}, [x: 1]], alll ~&gt; path(:x), fn x -&gt; x + 1 end) iex&gt; [1, 2, 3] = Pathex.view!(%{x: 1, y: 2, z: 3}, alll) |&gt; Enum.sort() iex&gt; {:ok, [x: 2, y: 2]} = Pathex.set([x: 1, y: 0], alll, 2)","ref":"Pathex.Lenses.html#all/0","title":"Pathex.Lenses.all/0","type":"function"},{"doc":"Path function which works with any possible key it can find It takes any key and than applies inner function (or concated path)Example:iex&gt; require Pathex iex&gt; anyl = Pathex.Lenses.any() iex&gt; {:ok, 1} = Pathex.view %{x: 1}, anyl iex&gt; {:ok, [9]} = Pathex.set [8], anyl, 9 iex&gt; {:ok, [x: 1, y: 2]} = Pathex.force_set [x: 0, y: 2], anyl, 1Note that force setting value to empty map has undefined behaviour and therefore returns an error:iex&gt; require Pathex iex&gt; anyl = Pathex.Lenses.any() iex&gt; :error = Pathex.force_set(%{}, anyl, :well)And note that this lens has keywords at head of list at a higher priority than non-keyword heads:iex&gt; require Pathex iex&gt; anyl = Pathex.Lenses.any() iex&gt; {:ok, [{:x, 1}, 2]} = Pathex.set([{:x, 0}, 2], anyl, 1) iex&gt; {:ok, [1, {:x, 2}]} = Pathex.set([0, {:x, 2}], anyl, 1) iex&gt; {:ok, [1, 2]} = Pathex.set([{&quot;some_tuple&quot;, &quot;here&quot;}, 2], anyl, 1)","ref":"Pathex.Lenses.html#any/0","title":"Pathex.Lenses.any/0","type":"function"},{"doc":"Path function for tuple with specified first elementExample:iex&gt; require Pathex; import Pathex iex&gt; okl = Pathex.Lenses.either(:ok) iex&gt; 8 = view! {:ok, 8}, okl iex&gt; {:ok, 10} = set! {:ok, 8}, okl, 10 iex&gt; {:ok, 123} = force_set! {:error, :x}, okl, 123","ref":"Pathex.Lenses.html#either/1","title":"Pathex.Lenses.either/1","type":"function"},{"doc":"","ref":"Pathex.Lenses.html#extend_if_ok/3","title":"Pathex.Lenses.extend_if_ok/3","type":"macro"},{"doc":"Path function which works like unix path ./ Works with every existing value (not only Enumerable)Example:iex&gt; require Pathex iex&gt; idl = Pathex.Lenses.id() iex&gt; {:ok, 8} = Pathex.view 8, idl iex&gt; {:ok, 9} = Pathex.set 8, idl, 9 iex&gt; {:ok, 9} = Pathex.force_set 8, idl, 9","ref":"Pathex.Lenses.html#id/0","title":"Pathex.Lenses.id/0","type":"function"},{"doc":"Path function which applies inner function (or concated path-closure) to every value it can apply it toExample:iex&gt; require Pathex; import Pathex iex&gt; starl = Pathex.Lenses.star() iex&gt; [1, 2] = Pathex.view!(%{x: [1], y: [2], z: 3}, starl ~&gt; path(0)) |&gt; Enum.sort() iex&gt; %{x: %{y: 1}, z: [3]} = Pathex.set!(%{x: %{y: 0}, z: [3]}, starl ~&gt; path(:y, :map), 1) iex&gt; {:ok, [1, 2, 3]} = Pathex.view([x: 1, y: 2, z: 3], starl)Note:Force update works the same way as all lensAnd update leaves unusable data unchanged","ref":"Pathex.Lenses.html#star/0","title":"Pathex.Lenses.star/0","type":"function"},{"doc":"Module for building combinations into path-closures","ref":"Pathex.Builder.html","title":"Pathex.Builder","type":"behaviour"},{"doc":"Implementation takes combination for path-closure and returns code structure to be built into some case of path-closure","ref":"Pathex.Builder.html#c:build/1","title":"Pathex.Builder.build/1","type":"callback"},{"doc":"This function creates quoted fn-closure from passed combination and operationsClosure has two arguments: operation name and tuple or actual argumentsIt will look likeiex&gt; fn :view, {struct} -&gt; ... :update, {struct, fun} -&gt; ... ... end","ref":"Pathex.Builder.html#build/2","title":"Pathex.Builder.build/2","type":"function"},{"doc":"This function creates quoted path-closure which is a composition of multiple quoted paths","ref":"Pathex.Builder.html#build_composition/2","title":"Pathex.Builder.build_composition/2","type":"function"},{"doc":"This function creates quoted fn-closure from passed combination and builderClosure has as much arguments as specified builder creates","ref":"Pathex.Builder.html#build_only/2","title":"Pathex.Builder.build_only/2","type":"function"},{"doc":"","ref":"Pathex.Builder.html#t:t/0","title":"Pathex.Builder.t/0","type":"type"},{"doc":"Structure for working with closures as ASTsFieldsvars - list of variables/argumentscode - body of a closure","ref":"Pathex.Builder.Code.html","title":"Pathex.Builder.Code","type":"module"},{"doc":"Converts code structures to quoted fn-statement with multiple clauses","ref":"Pathex.Builder.Code.html#multiple_to_fn/1","title":"Pathex.Builder.Code.multiple_to_fn/1","type":"function"},{"doc":"Simply creates new Code structure","ref":"Pathex.Builder.Code.html#new/2","title":"Pathex.Builder.Code.new/2","type":"function"},{"doc":"Converts quoted code with list of quoted vars to piped %Code{} with first arg piping into quoted code","ref":"Pathex.Builder.Code.html#new_arg_pipe/2","title":"Pathex.Builder.Code.new_arg_pipe/2","type":"function"},{"doc":"Converts code structure to quoted def-statement","ref":"Pathex.Builder.Code.html#to_def/2","title":"Pathex.Builder.Code.to_def/2","type":"function"},{"doc":"Converts code structure to quoted fn-closure","ref":"Pathex.Builder.Code.html#to_fn/1","title":"Pathex.Builder.Code.to_fn/1","type":"function"},{"doc":"","ref":"Pathex.Builder.Code.html#t:code_type/0","title":"Pathex.Builder.Code.code_type/0","type":"type"},{"doc":"","ref":"Pathex.Builder.Code.html#t:t/0","title":"Pathex.Builder.Code.t/0","type":"type"},{"doc":"Module for combination structures","ref":"Pathex.Combination.html","title":"Pathex.Combination","type":"module"},{"doc":"Simply transforms passed path into combination","ref":"Pathex.Combination.html#from_path/1","title":"Pathex.Combination.from_path/1","type":"function"},{"doc":"","ref":"Pathex.Combination.html#size/1","title":"Pathex.Combination.size/1","type":"function"},{"doc":"Transforms combination into list of paths this combination defines","ref":"Pathex.Combination.html#to_paths/1","title":"Pathex.Combination.to_paths/1","type":"function"},{"doc":"Plain representation of one path for generating one case(do:) or one matchable case","ref":"Pathex.Combination.html#t:path/0","title":"Pathex.Combination.path/0","type":"type"},{"doc":"Representation of one path combinationFor example:[ [map: :x, keyword: :x] [map: :y] ]Will expand tocase do %{x: inner} -&gt; case inner do %{y: value} -&gt; {:ok, value} _ -&gt; :error end [_ | _] = keyword-&gt; case Keyword.fetch(keyword, :x) do {:ok, inner} -&gt; case inner do %{y: value} -&gt; {:ok, value} _ -&gt; :error end _ -&gt; :error end _ -&gt; :error end","ref":"Pathex.Combination.html#t:t/0","title":"Pathex.Combination.t/0","type":"type"},{"doc":"Module for working with modifiers for paths Like :naive, :json, :map","ref":"Pathex.Operations.html","title":"Pathex.Operations","type":"module"},{"doc":"","ref":"Pathex.Operations.html#filter_combination/2","title":"Pathex.Operations.filter_combination/2","type":"function"},{"doc":"This functions returns map of builders for each specified modifier","ref":"Pathex.Operations.html#from_mod/1","title":"Pathex.Operations.from_mod/1","type":"function"},{"doc":"","ref":"Pathex.Operations.html#t:name/0","title":"Pathex.Operations.name/0","type":"type"},{"doc":"","ref":"Pathex.Operations.html#t:t/0","title":"Pathex.Operations.t/0","type":"type"},{"doc":"Module for parsing path created with sigils","ref":"Pathex.Parser.html","title":"Pathex.Parser","type":"module"},{"doc":"","ref":"Pathex.Parser.html#parse/2","title":"Pathex.Parser.parse/2","type":"function"},{"doc":"Utils module for parsing paths created with Pathex.path/2","ref":"Pathex.QuotedParser.html","title":"Pathex.QuotedParser","type":"module"},{"doc":"","ref":"Pathex.QuotedParser.html#parse/3","title":"Pathex.QuotedParser.parse/3","type":"function"},{"doc":"","ref":"Pathex.QuotedParser.html#parse_composition/2","title":"Pathex.QuotedParser.parse_composition/2","type":"function"},{"doc":"Viewer-builder which creates function which matches with one big case","ref":"Pathex.Builder.MatchableViewer.html","title":"Pathex.Builder.MatchableViewer","type":"module"},{"doc":"Callback implementation for Pathex.Builder.build/1.","ref":"Pathex.Builder.MatchableViewer.html#build/1","title":"Pathex.Builder.MatchableViewer.build/1","type":"function"},{"doc":"Simple viewer-builder for functions which apply func to value in the pathWith workaround to expand local macros to not create another function call","ref":"Pathex.Builder.SimpleViewer.html","title":"Pathex.Builder.SimpleViewer","type":"module"},{"doc":"Callback implementation for Pathex.Builder.build/1.","ref":"Pathex.Builder.SimpleViewer.html#build/1","title":"Pathex.Builder.SimpleViewer.build/1","type":"function"},{"doc":"","ref":"Pathex.Builder.SimpleViewer.html#wrap_ok/1","title":"Pathex.Builder.SimpleViewer.wrap_ok/1","type":"macro"},{"doc":"Module with common functions for viewers","ref":"Pathex.Builder.Viewer.html","title":"Pathex.Builder.Viewer","type":"module"},{"doc":"","ref":"Pathex.Builder.Viewer.html#create_getter/2","title":"Pathex.Builder.Viewer.create_getter/2","type":"function"},{"doc":"","ref":"Pathex.Builder.Viewer.html#fallback/0","title":"Pathex.Builder.Viewer.fallback/0","type":"function"},{"doc":"","ref":"Pathex.Builder.Viewer.html#match_from_path/2","title":"Pathex.Builder.Viewer.match_from_path/2","type":"function"},{"doc":"Forceupdater-builder which builds function for updates in given path","ref":"Pathex.Builder.ForceUpdater.html","title":"Pathex.Builder.ForceUpdater","type":"module"},{"doc":"Returns three argument code structure","ref":"Pathex.Builder.ForceUpdater.html#build/1","title":"Pathex.Builder.ForceUpdater.build/1","type":"function"},{"doc":"Module with common functions for updaters","ref":"Pathex.Builder.Setter.html","title":"Pathex.Builder.Setter","type":"module"},{"doc":"","ref":"Pathex.Builder.Setter.html#create_setter/2","title":"Pathex.Builder.Setter.create_setter/2","type":"function"},{"doc":"","ref":"Pathex.Builder.Setter.html#fallback/0","title":"Pathex.Builder.Setter.fallback/0","type":"function"},{"doc":"","ref":"Pathex.Builder.Setter.html#wrap_to_code/2","title":"Pathex.Builder.Setter.wrap_to_code/2","type":"function"},{"doc":"Updater-builder which generates function for simply updates value in the given path","ref":"Pathex.Builder.SimpleUpdater.html","title":"Pathex.Builder.SimpleUpdater","type":"module"},{"doc":"Callback implementation for Pathex.Builder.build/1.","ref":"Pathex.Builder.SimpleUpdater.html#build/1","title":"Pathex.Builder.SimpleUpdater.build/1","type":"function"},{"doc":"Behaviour for building quoted composition-closures of multiple paths","ref":"Pathex.Builder.Composition.html","title":"Pathex.Builder.Composition","type":"behaviour"},{"doc":"Builds composition of path-closure specified as quoted variables in input list","ref":"Pathex.Builder.Composition.html#c:build/1","title":"Pathex.Builder.Composition.build/1","type":"callback"},{"doc":"This builder builds composition for &amp;&amp;&amp; operator","ref":"Pathex.Builder.Composition.And.html","title":"Pathex.Builder.Composition.And","type":"module"},{"doc":"Callback implementation for Pathex.Builder.Composition.build/1.","ref":"Pathex.Builder.Composition.And.html#build/1","title":"Pathex.Builder.Composition.And.build/1","type":"function"},{"doc":"This builder builds composition for ||| operator","ref":"Pathex.Builder.Composition.Or.html","title":"Pathex.Builder.Composition.Or","type":"module"},{"doc":"Callback implementation for Pathex.Builder.Composition.build/1.","ref":"Pathex.Builder.Composition.Or.html#build/1","title":"Pathex.Builder.Composition.Or.build/1","type":"function"},{"doc":"Util functions for working with AST","ref":"Pathex.Common.html","title":"Pathex.Common","type":"module"},{"doc":"","ref":"Pathex.Common.html#detect_variables/2","title":"Pathex.Common.detect_variables/2","type":"function"},{"doc":"","ref":"Pathex.Common.html#is_var/1","title":"Pathex.Common.is_var/1","type":"macro"},{"doc":"","ref":"Pathex.Common.html#list_match/2","title":"Pathex.Common.list_match/2","type":"function"},{"doc":"","ref":"Pathex.Common.html#pin/1","title":"Pathex.Common.pin/1","type":"function"},{"doc":"","ref":"Pathex.Common.html#to_case/1","title":"Pathex.Common.to_case/1","type":"function"},{"doc":"","ref":"Pathex.Common.html#update_variables/3","title":"Pathex.Common.update_variables/3","type":"function"},{"doc":"Simple exception for bang! functions errors. Some new field may be added in the future","ref":"Pathex.Error.html","title":"Pathex.Error","type":"exception"},{"doc":"PathexFast. Really fast.","ref":"readme.html","title":"Pathex","type":"extras"},{"doc":"Pathex is a library for performing fast actions with nested data structures in Elixir. With pathex you can trivially set, get and update values in structures. It provides all necessary logic to manipulate data structures in different ways","ref":"readme.html#what-is-pathex","title":"Pathex - What is Pathex?","type":"extras"},{"doc":"Existing methods of accesssing data in nested structures are either slow (Focus for example) or do not provide much functionality (put_in or get_in for example). For example setting the value in structure with Pathex is 5-10x faster than Focus or 2x faster than put_inYou can checkout benchmarks at https://github.com/hissssst/pathex_bench","ref":"readme.html#why-another-library","title":"Pathex - Why another library?","type":"extras"},{"doc":"You can find complete documentation with examples, howto's, guides as https://hexdocs.pm/pathex","ref":"readme.html#complete-documentation","title":"Pathex - Complete documentation","type":"extras"},{"doc":"def deps do [ {:pathex, &quot;~&gt; 1.0.0&quot;} ] end","ref":"readme.html#installation","title":"Pathex - Installation","type":"extras"},{"doc":"You need to import and require Pathex since it's manly operates macrosrequire Pathex import Pathex, only: [path: 1, path: 2, &quot;~&gt;&quot;: 2]Note: There is no __using__/2 macro since it's better to explicitly define what macros will be exportedYou need to create the path which defines the path to the item in elixir structure you want to get:path_to_strees = path :user / :private / :addresses / 0 / :street path_in_json = ~P&quot;users/1/street&quot;jsonThis creates closure with fn which can get, set and update values in this pathUse the path!{:ok, &quot;6th avenue&quot; = street} = %{ user: %{ id: 1, name: &quot;hissssst&quot;, private: %{ phone: &quot;123-456-789&quot;, addresses: [ [city: &quot;City&quot;, street: &quot;6th avenue&quot;, mail_index: 123456] ] } } } |&gt; Pathex.view(path_to_streets) %{ &quot;users&quot; =&gt; %{ &quot;1&quot; =&gt; %{&quot;street&quot; =&gt; &quot;6th avenue&quot;} } } = Pathex.force_set!(%{}, path_in_json, street)","ref":"readme.html#usage","title":"Pathex - Usage","type":"extras"},{"doc":"Paths are really a set of pattern-matching cases. This is done to extract maximum efficency from BEAM's pattern-matching compiler# code for viewing variables for path iex&gt; path 1 / &quot;y&quot; # almost equals to case do %{1 =&gt; x} -&gt; case x do %{&quot;y&quot; =&gt; res} -&gt; {:ok, res} _ -&gt; :error end [_, x | _] -&gt; case x do %{&quot;y&quot; =&gt; res} -&gt; {:ok, res} _ -&gt; :error end t when is_tuple(t) and tuple_size(t) &gt; 1 -&gt; case x do %{&quot;y&quot; =&gt; res} -&gt; {:ok, res} _ -&gt; :error end endPaths for special specifications can be created with sigilsiex&gt; mypath = ~P[user/name/firstname]json iex&gt; Pathex.over(%{&quot;user&quot; =&gt; %{&quot;name&quot; =&gt; %{&quot;firstname&quot; =&gt; &quot;hissssst&quot;}}}, mypath, &amp;String.capitalize/1) {:ok, %{&quot;user&quot; =&gt; %{&quot;name&quot; =&gt; %{&quot;firstname&quot; =&gt; &quot;Hissssst&quot;}}}}iex&gt; mypath = ~P[:hey/&quot;hey&quot;]naive iex&gt; Pathex.set([hey: %{&quot;hey&quot; =&gt; 1}], mypath, 2) {:ok, [hey: %{&quot;hey&quot; =&gt; 2}]}You can use variables inside pathsiex&gt; index = 1 iex&gt; mypath = path :name / index iex&gt; Pathex.view %{name: {&quot;Linus&quot;, &quot;Torvalds&quot;}}, mypath {:ok, &quot;Torvalds&quot;} iex&gt; index = 0 # Note that captured variables can not be overriden iex&gt; Pathex.view %{name: {&quot;Linus&quot;, &quot;Torvalds&quot;}}, mypath {:ok, &quot;Torvalds&quot;}You can create composition of lensesiex&gt; path1 = path :user iex&gt; path2 = path :phones / 1 iex&gt; composed_path = path1 ~&gt; path2 iex&gt; Pathex.view %{user: %{phones: [&quot;123-456-789&quot;, &quot;987-654-321&quot;, &quot;000-111-222&quot;]}}, composed_path {:ok, &quot;987-654-321&quot;}Paths can be applied to different types of structuresiex&gt; user_path = path :user iex&gt; Pathex.view %{user: &quot;hissssst&quot;}, user_path {:ok, &quot;hissssst&quot;} iex&gt; Pathex.view [user: &quot;hissssst&quot;], user_path {:ok, &quot;hissssst&quot;}","ref":"readme.html#features","title":"Pathex - Features","type":"extras"},{"doc":"Pathex paths are just closures created with fn. Any path or ~P is a macro for creating a closure. Pathex.view/2, Pathex.set/3, Pathex.over/3 and etc are just macros for calling these closures. Pathex.~&gt;/2 is a simple macro which creates composition of two closures","ref":"readme.html#no-magic","title":"Pathex - No Magic","type":"extras"},{"doc":"Welcome! You can check existing TODO'sIf you have any suggestions or wan't to change something in this library don't hesitate to open an issueIf you have any whitepapers about functional lenses, you can add them in a PR to the bottom of this readme","ref":"readme.html#contributions","title":"Pathex - Contributions","type":"extras"},{"doc":"BasicsThis guide will show the basics of Pathex.","ref":"basics.html","title":"Basics","type":"extras"},{"doc":"Path-closure should be created with Pathex.path/2 or Pathex.sigil_P/2For example:iex&gt; p = path :x / 0Paths created with Pathex.path/2 can have atoms, strings, integers, variables and anything else what can be used in pattern-matching. This means that passing function calls straight into Pathex.path/2 is not allowed and will result in a compilation errorNote: You don't have to capture used variablesiex&gt; x = 1 iex&gt; path :some_atom / x # Right iex&gt; path :some_atom / ^x # WrongStrings, tuples, maps, functions, lists are treated as only Map keys.Atoms are treated as Map or Keyword keys.Positive integers are treated as Map keys or List and Tuple indexesNegative integers are treated as Map keys or first element in List's view or prepending element in List's update or force_set operationsVariables are treated as other types. For example, variables containing negative integers are treated as negative integer values","ref":"basics.html#create-paths","title":"Basics - Create paths","type":"extras"},{"doc":"There are plently ways to use created paths. Every macro with human-readable name (except path and sigil_P) is a macro for using pathex. In all such macros first argument is an input structure and the second argument is a path-closure itselfNote: Path-closure which are created inside path-using macro are optimised to have only one operation generated (instead of default three). You can read more about path-closures and operations hereMacro without ! always return {:ok, result} or :errorMacro with ! return result or raise Pathex.Error","ref":"basics.html#use-paths","title":"Basics - Use paths","type":"extras"},{"doc":"Path-closures can be composed together to create new path-closure, every path comosition macro is a binary operator. Some compositions are optimized to have generate one closure even if multiple closures are used.You can concat paths with Pathex.~&gt;/2 composition macroiex&gt; p1 = path :x iex&gt; p2 = path :y iex&gt; composed_path = p1 ~&gt; p2 iex&gt; 1 = Pathex.view(%{x: [y: 1]}, composed_path)","ref":"basics.html#compose-paths","title":"Basics - Compose paths","type":"extras"},{"doc":"Pathex provides some prebuilt path-closure to solve exotic problems. You can find them in Pathex.Lenses module","ref":"basics.html#prebuilt-paths","title":"Basics - Prebuilt paths","type":"extras"},{"doc":"Common usageCommon usage of Pathex boils down to getters/setters for structures with defined set of fields","ref":"common.html","title":"Common usage","type":"extras"},{"doc":"For example, you have a wallet of user and you want to have a quick access to amount of currencies user has,State looks like:state = %{ user_data: %{ name: &quot;...&quot;, private: %{ wallet: %{ &quot;USD&quot; =&gt; 123, &quot;EUR&quot; =&gt; 456 } } } }And getter for currency amount will look like:def currency(cur) do path :user_data / :private / :wallet / cur, :map endWith this you can set, get and update value in state and it's better than put_in, update_in because it'sFasterYou don't have to ensure that given field exsists when putting valueBefore:case state do %{user_data: %{private: %{wallet: %{^cur =&gt; _}}}} -&gt; put_in ..., amount %{user_data: %{private: %{wallet: %{}}}} -&gt; put_in ..., %{cur =&gt; amount} ... endAfter:Pathex.force_set(state, currency(cur), amount)","ref":"common.html#genserver-state-access","title":"Common usage - GenServer state access","type":"extras"},{"doc":"Sometimes you don't know if incoming structure will be Map or Keyword Pathex solves this problem by providing polymorphic input matching# For Keyword {:ok, 1} = [x: 1] |&gt; Pathex.view(path :x) # For Map {:ok, 1} = %{x: 1} |&gt; Pathex.view(path :x)","ref":"common.html#polymorphic-input","title":"Common usage - Polymorphic input","type":"extras"},{"doc":"Different API Versions","ref":"different-api-versions.html","title":"Different API Versions","type":"extras"},{"doc":"This tutorial shows the example of how Pathex solves some common data manipulation problems while it creates one more layer of abstraction. If you will have some problems with examples you can refer to test/guides/different_api_verstions_test.exs to have some more information about usage","ref":"different-api-versions.html#about","title":"Different API Versions - About","type":"extras"},{"doc":"Imagine a situation when you need to support different version of API.For example you webapplication path /api/v1/users should respond:[ { &quot;id&quot;: 1, &quot;name&quot;: &quot;Username1&quot;, &quot;personal_data&quot;: { &quot;phone&quot;: &quot;123&quot;, &quot;address&quot;: { &quot;street&quot;: &quot;6th ave&quot;, &quot;house&quot;: &quot;7/a&quot; } } }, { &quot;id&quot;: 2, &quot;name&quot;: &quot;Username2&quot;, &quot;personal_data&quot;: { &quot;phone&quot;: &quot;456&quot;, &quot;address&quot;: { &quot;street&quot;: &quot;1st ave&quot;, &quot;house&quot;: &quot;8/b&quot; } } } ]And /api/v2/users should respond:{ 1: { &quot;id&quot;: 1, &quot;name&quot;: &quot;Username1&quot;, &quot;phone&quot;: &quot;123&quot;, &quot;street&quot;: &quot;6th ave&quot;, &quot;house&quot;: &quot;7/a&quot; }, 2: { &quot;id&quot;: 2, &quot;name&quot;: &quot;Username2&quot;, &quot;phone&quot;: &quot;456&quot;, &quot;street&quot;: &quot;1st ave&quot;, &quot;house&quot;: &quot;8/b&quot; } }But your inner user representation looks like this:%User{ id: 1, name: &quot;Username1&quot;, phone: &quot;123&quot;, address: %Address{ id: 2, street: &quot;1st ave&quot;, house: &quot;8/b&quot; } }","ref":"different-api-versions.html#the-problem","title":"Different API Versions - The Problem","type":"extras"},{"doc":"You would have probably written different Views for different versions. But this is not the best solution becauseYou have to change every View for every change in the inner replresentation user-structureYou have to write completely new module for every new api versionYou have to write document2structures decoder for every api versionYou can't operate with parsed json while staying independent from api version","ref":"different-api-versions.html#part-1-straightforward-approach","title":"Different API Versions - Part 1. Straightforward approach","type":"extras"},{"doc":"To be inner-user-structure independent we should create lenses for Userdefmodule User do require Pathex import Pathex, only: [path: 1, path: 2] ... @doc &quot;This function returns lens for passed user attribute&quot; @spec attrlens(atom()) :: Pathex.t() def attrlens(attr) when attr in ~w[street house]a do path(:address / attr, :map) end def attrlens(attr), do: path(attr, :map) endAnd define single view which builds data using pathsdefmodule ApiView do require Pathex import Pathex, only: [path: 1, path: 2, &quot;~&gt;&quot;: 2] @attrs ~w[id name phone street house]a @doc &quot;Creates structure from users list&quot; def users_to_model(users, version) do Enum.reduce(users, [], &amp; add_user(&amp;1, &amp;2, version)) end @doc &quot;Adds user to model&quot; def add_user(%User{} = user, model, ver) do Enum.reduce(@attrs, model, fn attr, model -&gt; with( {:ok, value} &lt;- Pathex.view(user, User.attrlens(attr)), {:ok, model} &lt;- Pathex.force_set(model, userlens(ver, user, model) ~&gt; attrlens(ver, attr), value) ) do model else _ -&gt; model end end) end defp empty_model(:v1), do: [] defp empty_model(:v2), do: %{} # This functions defines where to put user defp userlens(:v1, %User{id: id}, model) do idx = Enum.find_index(model, &amp; match?(%{id: ^id}, &amp;1)) || -1 path idx end defp userlens(:v2, %User{id: id}, _) do path id, :map end # This function defines where to put attribute in user defp attrlens(:v1, attr) when attr in ~w[id name]a do path attr, :map end defp attrlens(:v1, attr) when attr in ~w[street house]a do path :personal_data / :address / attr, :map end defp attrlens(:v1, attr) do path :personal_data / attr, :map end # For version 2 defp attrlens(:v2, attr) do path attr, :map end end","ref":"different-api-versions.html#part-2-using-closures-with-pathex","title":"Different API Versions - Part 2. Using closures with Pathex","type":"extras"},{"doc":"Not much changed, it seems. But what if we make it more abstract and define another module for converting list of structures to aggregatable view back and forthdefmodule StructuresToAggregatableView do require Pathex import Pathex, only: [path: 1, path: 2, &quot;~&gt;&quot;: 2] @doc &quot;Converts list of users into model&quot; def to_model(users, ver, %{ attrs: attrs, userattrl: userattrl, userl: userl, modelattrl: modelattrl, initial_model: model }) do for user &lt;- users, attr &lt;- attrs, reduce: model.(ver) do model -&gt; modell = userl.(ver, user.id, model) ~&gt; modelattrl.(ver, attr) with( {:ok, value} &lt;- Pathex.view(user, userattrl.(attr)), {:ok, model} &lt;- Pathex.force_set(model, modell, value) ) do model else _ -&gt; model end end end @doc &quot;Converts model into list of users&quot; def to_users(model, ver, %{ attrs: attrs, userattrl: userattrl, modelattrl: modelattrl, modeliteml: modeliteml }) do for item &lt;- model, into: [] do for attr &lt;- attrs, reduce: %{} do user -&gt; with( {:ok, value} &lt;- Pathex.view(item, modeliteml.(ver) ~&gt; modelattrl.(ver, attr)), {:ok, user} &lt;- Pathex.force_set(user, userattrl.(attr), value) ) do user else _ -&gt; user end end end end endIn this module we can use same configuration for every function. Looks nice but both functions seem to look the same way...","ref":"different-api-versions.html#part-3-functional-flavour","title":"Different API Versions - Part 3. Functional flavour","type":"extras"},{"doc":"defmodule AggrToAggr do require Pathex @doc &quot;Function which converts one aggregatable data structure to another back and forth&quot; def convert(from, %{ froml: froml, # Closure which returns path to attribute in input structure&#39;s item tol: tol, # Closure which returns path to attribute in output structure&#39;s item initial: initial, # Initial output structure which will be used to insert items into inner: inner, # Initial output structure&#39;s item which will be filled with values of attributes keys: keys # List of attributes to be called }) do Enum.into(from, initial, fn item -&gt; Enum.reduce(keys, inner, fn key, acc -&gt; with( {:ok, value} &lt;- Pathex.view(item, froml.(key)), {:ok, acc} &lt;- Pathex.force_set(acc, tol.(key), value) ) do acc else _ -&gt; acc end end) end) end endThis module uses Enum.into/3 to create aggregatable structure from other aggregatable structure with two lenses, inner value and initial output structure. The downside of this decidion is that we can't pass version number straight into the closure, but we can creates partially filled closure with &amp; userl.(ver, &amp;1)Did we solve the problems?You have to change every View for every change in the inner replresentation user-structureWe need to change only one functon, the one which returns path to attribute in UserYou have to write completely new module for every new api versionYou just need to specify one function, the one which returns path to attribute in modelYou have to write document2structures decoder for every api versionWith pathex encoding-decoding process works back and forthYou can't operate with parsed json while staying independent from api versionYou can take value from the model with function (which returns path) you've created for this version of model","ref":"different-api-versions.html#part-4-completely-functional","title":"Different API Versions - Part 4. Completely functional","type":"extras"},{"doc":"Modifiers tutorialEvery pathex path created with path/2 or ~P[] can have modifier specified next to it. Modifier defines behaviour of the path in a way of structures it can match inside For example, path created with :map modifier can only match maps inside them","ref":"modifiers.html","title":"Modifiers tutorial","type":"extras"},{"doc":"Currently only three modifiers are avaliable::json which matches lists and maps:naive which matches lists, tuples, keywords and maps:map which matches only mapsDefault modifier for every path is :naiveModifiers are specified as second argument in path/2 likepath(:x / :y, :naive) path(0 / :x, :json)Or for sigil paths like~P[:x/:y/1]naive ~P[x/y/1]json","ref":"modifiers.html#usage","title":"Modifiers tutorial - Usage","type":"extras"},{"doc":"This modifier matches lists, tuples, keyword and maps It generates matches for every structure likecase input do %{x: value} -&gt; ... [{a, _} | _] = k when is_atom(a) -&gt; case Keyword.fetch(k, :x) do ... end endNote: Variables are treaded as their values","ref":"modifiers.html#naive-modifier","title":"Modifiers tutorial - Naive modifier","type":"extras"},{"doc":"This modifier macthes lists (for integer keys only) and mapsNote: This modifier treats variables as map keys, this means thatiex&gt; x = 1 iex&gt; p = path x, :json iex&gt; :error = Pathex.view([1, 2, 3], p) iex&gt; {:ok, :x} = Pathex.view(%{1 =&gt; :x}, p)But passed integers are exanded into list matching this makes it very efficent for view data from structureFor example path(1 / :x, :json) will generate closure withcase input do [_, %{x: value} | _] -&gt; {:ok, value} %{1 =&gt; %{x: value}} -&gt; {:ok, value} _ -&gt; :error endWhich extracts maximum efficency from BEAM's pattern-matchingNote that :json path will have its argument without type syntax This means that ~P[x/y/1] will treat x like string, y like string and 1 like integer and string","ref":"modifiers.html#json-modifier","title":"Modifiers tutorial - Json modifier","type":"extras"},{"doc":"This modifier matches only maps and therefore is the fastest modifier avaliableFor example path(1 / :x / &quot;y&quot;, :json) will generate closure withcase input do %{1 =&gt; %{x: %{&quot;y&quot; =&gt; value}}} -&gt; {:ok, value} _ -&gt; :error end","ref":"modifiers.html#map-modifier","title":"Modifiers tutorial - Map modifier","type":"extras"},{"doc":"You should use modifiers when you need to specify type of inner structures to match or reduce amount of generated code by Pathex or improve performance of the path","ref":"modifiers.html#when-how-why","title":"Modifiers tutorial - When? How? &amp; Why?","type":"extras"},{"doc":"PathThis page describes what a Pathex.t() is and how to create and use one","ref":"path.html","title":"Path","type":"extras"},{"doc":"Create: As described in README and Pathex simple paths can be created with Pathex.path/2 and Pathex.sigil_P/2 macrosUse: This paths then can be called using macro-helpers from Pathex like Pathex.view/2 or Pathex.force_set/3Prebuilt: some non-trivial prebuilt lenses are avaliable in Pathex.Lenses module","ref":"path.html#basic","title":"Path - Basic","type":"extras"},{"doc":"Every path-closure is a closure of two arguments:Operation name (atom)Operation arguments, tuple which size depends on an operationCurrently every path-closure has 3 operations:path_closure = fn # Operation which gets value from structure and retuns `function.(value)` :view, {structure, function} -&gt; ... # Operation which returns new structure with updated value :update, {structure, function} -&gt; ... # Operation which returns new structure with updated value, or default set :force_update, {structure, function, default} -&gt; ... endPath-closure must return {:ok, any()} | :error for every valid operation call and raise if non-exsisting operation is calledPath-closures create by Pathex.path/2 or Pathex.sigil_P/2 are totally pure functions with no side effects","ref":"path.html#internal-representation","title":"Path - Internal representation","type":"extras"}]